f# rom micropython import const
# import framebuf
from hybotics_ht16k33.ht16k33 import HT16K33

class HT16K33Matrix(HT16K33):
    def __init__(self, i2c, address=0x70):
        super().__init__(i2c, address)

        self._fb_buffer = bytearray(self.WIDTH * self.HEIGHT
                                    * self.FB_BPP // 8)
        self.framebuffer = framebuf.FrameBuffer(
            self._fb_buffer, self.WIDTH, self.HEIGHT, self.FORMAT)

        self.framebuffer.fill(0)
        self.pixel = self.framebuffer.pixel
        self.fill = self.framebuffer.fill

    def show(self):
        self._copy_buf()
        super().show()

class Matrix8x8x2(HT16K33Matrix):
    WIDTH = 8
    HEIGHT = 8
    FORMAT = framebuf.GS4_HMSB
    FB_BPP = 4

    def _copy_buf(self):
        pixel = self.framebuffer.pixel
        _buffer = self.buffer
        for y in range(8):
            b = 0
            for x in range(8):
                color = pixel(x, y)
                if color & 0x01:
                    b |= 0x01 << x
                if color & 0x02:
                    b |= 0x01 << (x + 8)
            _buffer[y * 2] = b & 0xff
            _buffer[y * 2 + 1] = (b >> 8) & 0xff
